; DIGGER.ASM				(R. CUTLER,  06/20/91)
; Copyright (C) 1991 by Cutler Digital Design

   ;************************************************************
   ;***                      INCLUDES
   ;************************************************************

	include lmacros.h

;*******
; ASSEMBLER FLAGS
;

;NONMI	EQU	1

   ;***  CONSTANTS  ***************************************
   
ZERO     EQU     00H
BIT0     EQU     1H
BIT1     EQU     2H
BIT2     EQU     4H
BIT3     EQU     8H
BIT4     EQU     10H
BIT5     EQU     20H
BIT6     EQU     40H
BIT7     EQU     80H
XON      EQU     17
XOFF     EQU     19
STARTBYTE EQU	13
OFF	EQU	0
ON	EQU	1

MINUSONE  EQU    FFFFH

ROM      EQU   0F800H    ;***  Beginning of ROM (paragraph)
RAM      EQU   00H       ;***  Beginning of RAM (paragraph)
                         ;***  BOOT address = F800:7FF0H
                         
; IO ADDRESS SPACE

UART	EQU	00H
PIA	EQU	40H
SLEEPAD	EQU	80H
CLRNMI	EQU	0C0H
;	ADDRESS
PARBASE	EQU	040H
SERBASE EQU	000H
SLEEPFLOP EQU	080H
PARAA	EQU	PARBASE
PARB	EQU	PARBASE+1
PARC	EQU	PARBASE+2
PARCON	EQU	PARBASE+3
SERCON	EQU	SERBASE+1
SERDAT	EQU	SERBASE

;     OUTPUT   76543210 TO PARALLEL CONTROL BYTE
;              1        SET PARALLEL MODE
;              0        BIT CHANGE FOR PORT C
;               00       PORT A AND UPPER C MODE ZERO (BASIC I/O)
;               01       PORT A AND UPPER C MODE ONE (STROBED I/O)
;               10       PORT A AND UPPER C MODE TWO (BIDIR I/O)
;               11       PORT A AND UPPER C MODE TWO (BIDIR I/O)
;                 1       PORT A - INPUT
;                 0       PORT A - OUTPUT
;                  1       PORT C(UPPER) - INPUT
;                  0       PORT C(UPPER) - OUTPUT
;                   0       PORT B AND LOWER C MODE ZERO (BASIC I/O)
;                   1       PORT B AND LOWER C MODE ONE (STROBED I/O)
;                    1       PORT B - INPUT
;                    0       PORT B - OUTPUT
;                     1 PORT C(LOWER) - INPUT
;                     0 PORT C(LOWER) - OUTPUT
SETPARMODE      EQU     BIT7
BITWIDC         EQU     ZERO
ABASIC          EQU     ZERO
ASTROBE         EQU     BIT5
ABIDIR          EQU     BIT6
AINPUT          EQU     BIT4
AOUTPUT         EQU     ZERO
CUPIN           EQU     BIT3
CUPOUT          EQU     ZERO
BBASIC          EQU     ZERO
BSTROBE         EQU     BIT2
BINPUT          EQU     BIT1
BOUTPUT         EQU     ZERO
CDOWNIN         EQU     BIT0
CDOWNOUT        EQU     ZERO

; A/D AND MUX CONSTANTS
RESET		EQU	0
NORESET		EQU	128
SCLOCK		EQU	0
NOSCLOCK	EQU	64
ADSLEEP		EQU	0
NOADSLEEP	EQU	32
HOLD		EQU	16
NOHOLD		EQU	0
ENABLEMUX	EQU	8
DISABLEMUX	EQU	0
CHAN7		EQU	7
CHAN6		EQU	6
CHAN5		EQU	5
CHAN4		EQU	4
CHAN3		EQU	3
CHAN2		EQU	2
CHAN1		EQU	1
CHAN0		EQU	0
RESETBIT	EQU	80H
SCLOCKBIT	EQU	40H
ADSLEEPBIT	EQU	20H
HOLDBIT		EQU	10H
MUXBIT		EQU	8
NOTRESETBIT	EQU	07FH
NOTSCLOCKBIT	EQU	0BFH
NOTADSLEEPBIT	EQU	0DFH
NOTHOLDBIT	EQU	0EFH
NOTMUXBIT	EQU	0F7H
;	MOV	AL,RESET + NOSCLOCK + NOADSLEEP + NOHOLD + ENABLEMUX + CHAN0
;	OUTPT	PARAA,AL

   ;************************************************************
   ;***                      MACROS                          ***
   ;************************************************************

SETC7	MACRO
	OUTPT	PARCON,0FH
	ENDM

SETC6	MACRO
	OUTPT	PARCON,0DH
	ENDM

SETC5	MACRO
	OUTPT	PARCON,0BH
	ENDM

SETC4	MACRO
	OUTPT	PARCON,09H
	ENDM

SETC3	MACRO
	OUTPT	PARCON,07H
	ENDM

SETC2	MACRO
	OUTPT	PARCON,05H
	ENDM

SETC1	MACRO
	OUTPT	PARCON,03H
	ENDM

SETC0	MACRO
	OUTPT	PARCON,01H
	ENDM

RESETC7	MACRO
	OUTPT	PARCON,0EH
	ENDM

RESETC6	MACRO
	OUTPT	PARCON,0CH
	ENDM

RESETC5	MACRO
	OUTPT	PARCON,0AH
	ENDM

RESETC4	MACRO
	OUTPT	PARCON,08H
	ENDM

RESETC3	MACRO
	OUTPT	PARCON,06H
	ENDM

RESETC2	MACRO
	OUTPT	PARCON,04H
	ENDM

RESETC1	MACRO
	OUTPT	PARCON,02H
	ENDM

RESETC0	MACRO
	OUTPT	PARCON,00H
	ENDM

RESETON	MACRO
;	INPUT	PARAA
	AND	AL,NOTRESETBIT
;	OUTPT	PARAA
	ENDM


SCLOCKON MACRO
;	INPUT	PARAA
	AND	AL,NOTSCLOCKBIT
;	OUTPT	PARAA
	ENDM

ADSLEEPON MACRO
;	INPUT	PARAA
	AND	AL,NOTADSLEEPBIT
;	OUTPT	PARAA
	ENDM

HOLDON	MACRO
;	INPUT	PARAA
	OR	AL,HOLDBIT
;	OUTPT	PARAA
	ENDM

MUXON	MACRO
;	INPUT	PARAA
	OR	AL,MUXBIT
;	OUTPT	PARAA
	ENDM

RESETOFF	MACRO
;	INPUT	PARAA
	OR	AL,RESETBIT
;	OUTPT	PARAA
	ENDM


SCLOCKOFF MACRO
;	INPUT	PARAA
	OR	AL,SCLOCKBIT
;	OUTPT	PARAA
	ENDM

ADSLEEPOFF MACRO
;	INPUT	PARAA
	OR	AL,ADSLEEPBIT
;	OUTPT	PARAA
	ENDM

HOLDOFF	MACRO
;	INPUT	PARAA
	AND	AL,NOTHOLDBIT
;	OUTPT	PARAA
	ENDM

MUXOFF	MACRO
;	INPUT	PARAA
	AND	AL,NOTMUXBIT
;	OUTPT	PARAA
	ENDM

   ;***  usage OUTPT  OUTPUT-PORT , VALUE

OUTPT	MACRO  ARG1,ARG2  ;***  Allows output of reg., mem. or constants

IF	ARG1 GT 255       ;***  Used by lots of routines
	IFDIF	<"DX">,<ARG1>
		MOV     DX,ARG1
	ENDIF
	IFDIF	<"AL">,<ARG2>
		MOV     AL,ARG2
	ENDIF
	OUT     DX,AL
ELSE
	IFDIF	<"AL">,<ARG2>
		MOV	AL,ARG2
	ENDIF
	OUT	ARG1,AL
ENDIF
        ENDM


   ;***  usage OUTPTL  OUTPUT-PORT(>255) , VALUE

OUTPTL	MACRO  ARG1,ARG2  ;***  Allows output of reg., mem. or constants
	MOV     DX,ARG1
	MOV     AL,ARG2
	OUT     DX,AL
        ENDM


   ;***  usage INPUT  INPUT-PORT

INPUT	MACRO  ARG1       ;***  Allows input to reg., mem. or constants
	IF	ARG1 GT 255       ;***  Used by lots of routines
	IFDIF	<"DX">,<ARG1>
        MOV     DX,ARG1
	ENDIF
        IN      AL,DX
	ELSE
	IN	AL,ARG1
	ENDIF
        ENDM

PUTSERCON MACRO	ARG1
	IFDIF	<ARG1>,<"AL">
	MOV	AL,ARG1
	ENDIF
	OUT	SERCON,AL
	CALL	SERPAS
;	CALL	SERPAS
	ENDM

GETSERCON MACRO
	IN	AL,SERCON
	CALL	SERPAS
;	CALL	SERPAS
	ENDM

PUTSERDAT MACRO	ARG1
	IFDIF	<ARG1>,<"AL">
	MOV	AL,ARG1
	ENDIF
	OUT	SERDAT,AL
	CALL	SERPAS
;	CALL	SERPAS
	ENDM

GETSERDAT MACRO
	IN	AL,SERDAT
	CALL	SERPAS
;	CALL	SERPAS
	ENDM

INTON	MACRO         ;***  Enable interrupts
	STI              ;***  (Used by InitIO & GITCH3)
        ENDM


INTOFF	MACRO      ;***  Disable interrupts 
	CLI              ;***  (InitIO, DOEDGE & GITCH1)
        ENDM

DISP	MACRO	ARG1
	LOCAL	DISP1
	LOCAL	DISP2
	LOCAL	DISP3
	LOCAL	DISP4
	PUSH	AX	;SAVE REGISTERS
	PUSH	BX
	JMP	DISP2	;JUMP TO CODE BELOW
DISP1:
	DB	ARG1	; TEXT STRING
	DB	0
DISP2:
	MOV	BX,OFFSET DISP1	;SET START OF STRING
DISP3:
	MOV	AL,CS:[BX]	;GET CHAR
	CMP	AL,00H
	JE	DISP4		; IF 0, THEN DONE
	CALL	PUTCH		;ELSE SEND IT
	INC	BX		; UPDATE POINTER
	JMP	DISP3		; AND LOOP
DISP4:
	POP	BX			; RESTORE REGISTERS
	POP	AX
	ENDM

DISPCR	MACRO	ARG1
	DISP	ARG1
	PUSH	AX
	CALL	CRLF
	POP	AX
	ENDM





;COMMENTS FROM MANX C SETUP:
;
;	If you want your stack at a fixed place, you may remove the
;	"bss cstack..." statement below and change the "mov sp,cstack..."
;	to load SP with the value you desire.  Note that the setup of
;	SS may need to be changed also.  If the program is small data
;	model, then SS must be equal to DS or pointers to automatic
;	variables won't work.
;
;	Otherwise, stacksize should be set according to your program's
;	requirements.
stacksize equ	2048
;
;	DATASEG is the data segment address (as a paragraph #)
;	this is picked from the -D option of the linker
;
;Dseg	equ	040H	;physical addr 0x400, just above the int vectors

; IT IS A LITTLE TRICKY ASSIGNING LOWER RAM, IT SEEMS THAT THE FIRST WORD
;   IN dataseg IS RESERVED FOR _DORG_.  INSERTING ORG STATMENTS SEEMS TO
;   ENFORCE A TWO BYTE OFFSET.

; INTERRUPT VECTORS:
DATASEG	segment	word public 'data'

	DW	?
	PUBLIC	VEC01
VEC01	DW	?
	DW	?
VEC02	DW	INTNMI
	DW	CODESEG
VEC03	DW	?
	DW	?
VEC04	DW	?
	DW	?
VEC05	DW	?
	DW	?
VEC06	DW	?
	DW	?
VEC07	DW	?
	DW	?
VEC08	DW	?
	DW	?
VEC09	DW	?
	DW	?
VEC0A	DW	?
	DW	?
VEC0B	DW	?
	DW	?
VEC0C	DW	?
	DW	?
VEC0D	DW	?
	DW	?
VEC0E	DW	?
	DW	?
VEC0F	DW	?
	DW	?
VEC10	DW	?
	DW	?
VEC11	DW	?
	DW	?
VEC12	DW	?
	DW	?
VEC13	DW	?
	DW	?
VEC14	DW	?
	DW	?
VEC15	DW	?
	DW	?
VEC16	DW	?
	DW	?
VEC17	DW	?
	DW	?
VEC18	DW	?
	DW	?
VEC19	DW	?
	DW	?
VEC1A	DW	?
	DW	?
VEC1B	DW	?
	DW	?
VEC1C	DW	?
	DW	?
VEC1D	DW	?
	DW	?
VEC1E	DW	?
	DW	?
VEC1F	DW	?
	DW	?

	PUBLIC	VEC20
VEC20	DW	INT1
	DW	CODESEG
	PUBLIC	VEC21
VEC21	DW	?
	DW	?
	PUBLIC	VEC22
VEC22	DW	?
	DW	?
VEC23	DW	?
	DW	?
VEC24	DW	?
	DW	?
VEC25	DW	?
	DW	?
	PUBLIC	VEC26
VEC26	DW	?
	DW	CODESEG
	PUBLIC	VEC27
VEC27	DW	?
	DW	CODESEG
VEC28	DW	?
	DW	?
VEC29	DW	?
	DW	?
VEC2A	DW	?
	DW	?
VEC2B	DW	?
	DW	?
VEC2C	DW	?
	DW	?
VEC2D	DW	?
	DW	?
VEC2E	DW	?
	DW	?
VEC2F	DW	?
	DW	?
VEC30	DW	?
	DW	?
VEC31	DW	?
	DW	?
VEC32	DW	?
	DW	?
VEC33	DW	?
	DW	?
VEC34	DW	?
	DW	?
VEC35	DW	?
	DW	?
VEC36	DW	?
	DW	?
VEC37	DW	?
	DW	?
VEC38	DW	?
	DW	?
VEC39	DW	?
	DW	?
VEC3A	DW	?
	DW	?
VEC3B	DW	?
	DW	?
VEC3C	DW	?
	DW	?
VEC3D	DW	?
	DW	?
VEC3E	DW	?
	DW	?
VEC3F	DW	?
	DW	?
VEC40	DW	INT2
	DW	CODESEG
VEC41	DW	?
	DW	?
VEC42	DW	?
	DW	?
VEC43	DW	?
	DW	?
VEC44	DW	?
	DW	?
VEC45	DW	?
	DW	?
VEC46	DW	?
	DW	?
VEC47	DW	?
	DW	?
VEC48	DW	?
	DW	?
VEC49	DW	?
	DW	?
VEC4A	DW	?
	DW	?
VEC4B	DW	?
	DW	?
VEC4C	DW	?
	DW	?
VEC4D	DW	?
	DW	?
VEC4E	DW	?
	DW	?
VEC4F	DW	?
	DW	?
VEC50	DW	?
	DW	?
VEC51	DW	?
	DW	?
VEC52	DW	?
	DW	?
VEC53	DW	?
	DW	?
VEC54	DW	?
	DW	?
VEC55	DW	?
	DW	?
VEC56	DW	?
	DW	?
VEC57	DW	?
	DW	?
VEC58	DW	?
	DW	?
VEC59	DW	?
	DW	?
VEC5A	DW	?
	DW	?
VEC5B	DW	?
	DW	?
VEC5C	DW	?
	DW	?
VEC5D	DW	?
	DW	?
VEC5E	DW	?
	DW	?
VEC5F	DW	?
	DW	?
VEC60	DW	INT3
	DW	CODESEG
VEC61	DW	?
	DW	?
VEC62	DW	?
	DW	?
VEC63	DW	?
	DW	?
VEC64	DW	?
	DW	?
VEC65	DW	?
	DW	?
VEC66	DW	?
	DW	?
VEC67	DW	?
	DW	?
VEC68	DW	?
	DW	?
VEC69	DW	?
	DW	?
VEC6A	DW	?
	DW	?
VEC6B	DW	?
	DW	?
VEC6C	DW	?
	DW	?
VEC6D	DW	?
	DW	?
VEC6E	DW	?
	DW	?
VEC6F	DW	?
	DW	?
VEC70	DW	?
	DW	?
VEC71	DW	?
	DW	?
VEC72	DW	?
	DW	?
VEC73	DW	?
	DW	?
VEC74	DW	?
	DW	?
VEC75	DW	?
	DW	?
VEC76	DW	?
	DW	?
VEC77	DW	?
	DW	?
VEC78	DW	?
	DW	?
VEC79	DW	?
	DW	?
VEC7A	DW	?
	DW	?
VEC7B	DW	?
	DW	?
VEC7C	DW	?
	DW	?
VEC7D	DW	?
	DW	?
VEC7E	DW	?
	DW	?
VEC7F	DW	?
	DW	?
VEC80	DW	INT4
	DW	CODESEG
VEC81	DW	?
	DW	?
VEC82	DW	?
	DW	?
VEC83	DW	?
	DW	?
VEC84	DW	?
	DW	?
VEC85	DW	?
	DW	?
VEC86	DW	?
	DW	?
VEC87	DW	?
	DW	?
VEC88	DW	?
	DW	?
VEC89	DW	?
	DW	?
VEC8A	DW	?
	DW	?
VEC8B	DW	?
	DW	?
VEC8C	DW	?
	DW	?
VEC8D	DW	?
	DW	?
VEC8E	DW	?
	DW	?
VEC8F	DW	?
	DW	?
VEC90	DW	?
	DW	?
VEC91	DW	?
	DW	?
VEC92	DW	?
	DW	?
VEC93	DW	?
	DW	?
VEC94	DW	?
	DW	?
VEC95	DW	?
	DW	?
VEC96	DW	?
	DW	?
VEC97	DW	?
	DW	?
VEC98	DW	?
	DW	?
VEC99	DW	?
	DW	?
VEC9A	DW	?
	DW	?
VEC9B	DW	?
	DW	?
VEC9C	DW	?
	DW	?
VEC9D	DW	?
	DW	?
VEC9E	DW	?
	DW	?
VEC9F	DW	?
	DW	?
VECA0	DW	INT5
	DW	CODESEG
VECA1	DW	?
	DW	?
VECA2	DW	?
	DW	?
VECA3	DW	?
	DW	?
VECA4	DW	?
	DW	?
VECA5	DW	?
	DW	?
VECA6	DW	?
	DW	?
VECA7	DW	?
	DW	?
VECA8	DW	?
	DW	?
VECA9	DW	?
	DW	?
VECAA	DW	?
	DW	?
VECAB	DW	?
	DW	?
VECAC	DW	?
	DW	?
VECAD	DW	?
	DW	?
VECAE	DW	?
	DW	?
VECAF	DW	?
	DW	?
VECB0	DW	?
	DW	?
VECB1	DW	?
	DW	?
VECB2	DW	?
	DW	?
VECB3	DW	?
	DW	?
VECB4	DW	?
	DW	?
VECB5	DW	?
	DW	?
VECB6	DW	?
	DW	?
VECB7	DW	?
	DW	?
VECB8	DW	?
	DW	?
VECB9	DW	?
	DW	?
VECBA	DW	?
	DW	?
VECBB	DW	?
	DW	?
VECBC	DW	?
	DW	?
VECBD	DW	?
	DW	?
VECBE	DW	?
	DW	?
VECBF	DW	?
	DW	?
VECC0	DW	INT6
	DW	CODESEG
VECC1	DW	?
	DW	?
VECC2	DW	?
	DW	?
VECC3	DW	?
	DW	?
VECC4	DW	?
	DW	?
VECC5	DW	?
	DW	?
VECC6	DW	?
	DW	?
VECC7	DW	?
	DW	?
VECC8	DW	?
	DW	?
VECC9	DW	?
	DW	?
VECCA	DW	?
	DW	?
VECCB	DW	?
	DW	?
VECCC	DW	?
	DW	?
VECCD	DW	?
	DW	?
VECCE	DW	?
	DW	?
VECCF	DW	?
	DW	?
VECD0	DW	?
	DW	?
VECD1	DW	?
	DW	?
VECD2	DW	?
	DW	?
VECD3	DW	?
	DW	?
VECD4	DW	?
	DW	?
VECD5	DW	?
	DW	?
VECD6	DW	?
	DW	?
VECD7	DW	?
	DW	?
VECD8	DW	?
	DW	?
VECD9	DW	?
	DW	?
VECDA	DW	?
	DW	?
VECDB	DW	?
	DW	?
VECDC	DW	?
	DW	?
VECDD	DW	?
	DW	?
VECDE	DW	?
	DW	?
VECDF	DW	?
	DW	?
VECE0	DW	INT7
	DW	CODESEG
VECE1	DW	?
	DW	?
VECE2	DW	?
	DW	?
VECE3	DW	?
	DW	?
VECE4	DW	?
	DW	?
VECE5	DW	?
	DW	?
VECE6	DW	?
	DW	?
VECE7	DW	?
	DW	?
VECE8	DW	?
	DW	?
VECE9	DW	?
	DW	?
VECEA	DW	?
	DW	?
VECEB	DW	?
	DW	?
VECEC	DW	?
	DW	?
VECED	DW	?
	DW	?
VECEE	DW	?
	DW	?
VECEF	DW	?
	DW	?
VECF0	DW	?
	DW	?
VECF1	DW	?
	DW	?
VECF2	DW	?
	DW	?
VECF3	DW	?
	DW	?
VECF4	DW	?
	DW	?
VECF5	DW	?
	DW	?
VECF6	DW	?
	DW	?
VECF7	DW	?
	DW	?
VECF8	DW	?
	DW	?
VECF9	DW	?
	DW	?
VECFA	DW	?
	DW	?
VECFB	DW	?
	DW	?
VECFC	DW	?
	DW	?
VECFD	DW	?
	DW	?
VECFE	DW	?
	DW	?
VECFF	DW	?
	DW	?

;MANX C DECLARATIONS
	public	$MEMRY
$MEMRY	dw	-1
	dw	-1
	public	errno_
errno_	dw	0
	public	_dsval_,_csval_
_dsval_	dw	0
_csval_	dw	0
	public	_mbot_, sbot
_mbot_	dw	0
	dw	0
sbot	dw	0
	dw	0
	extrn	_Dorg_:byte,_Dend_:byte
	extrn	_Uorg_:byte,_Uend_:byte
	public	cstack
	bss	cstack:byte,stacksize
DATASEG	ends
	extrn	_Corg_:byte,_Cend_:byte

ifdef	FARPROC
	extrn main_:far, $fltinit:far, TickInt_:far
else
	extrn main_:near, $fltinit:near, TickInt_:near
endif

;MANX C STARTUP CODE
;____________________________________________________________________
;____________________________________________________________________
;
;/////////////////   STARTUP ROUTINE CODE SPACE   \\\\\\\\\\\\\\\\\\\
;____________________________________________________________________
;____________________________________________________________________

	public	$begin
$begin	proc	far
; ASSUMES THAT THE NMI IS DISABLED AT THIS POINT
; SOFTWARE COLD RESETS MUST FORCE NMI TO A DUMMY ROUTINE
	cli
	cld
;
;	Compute where initialzed data starts (@ next para after code)
;
	mov	ax,offset _Cend_+15
	mov	cl,4
	shr	ax,cl
	add	ax,seg _Cend_
	mov	ds,ax		;place where data is in rom
	mov	bx,DATASEG	;place where data is to go in ram
	mov	es,bx
;
;	Note: For hardware reasons the instruction which loads SS should
;		be immediatly followed by the load of SP.
;
	mov	ss,bx
	mov	sp,offset cstack+stacksize
;
;		copy Init data from rom to ram
	mov	di,0
	mov	cx,offset _Dend_
	inc	cx
	shr	cx,1
	jcxz	nocopy
	mov	si,0
rep	movsw
nocopy:
;
;		clear uninitialized data

;**** don't zero uninitialized stuff
	jmp	noclear
;****
	mov	di,offset _Uorg_
	mov	cx,offset _Uend_
	sub	cx,di
	inc	cx
	shr	cx,1
	jcxz	noclear
	sub	ax,ax
rep	stosw
noclear:
;
	assume	ds:DATASEG,es:DATASEG

	mov	ds,bx			;set DS, now DS, SS, ES are equal


;************************************************************
;
; 8088 INIT CODE
;
;************************************************************
	ASSUME CS:CODESEG,DS:DATASEG,ES:DATASEG,SS:DATASEG

; ASSUME MASKABLE INTERRUPTS DISABLED, AND NMI DISABLED

; SET NMI TO DRIVE 300HZ CLOCK, AND RESET FLIPFLOP
; SET UP PARALLEL PORT PORT A AS OUTPUT PORT B AS INPUT PORT C AS OUTPUT
	OUTPT  PARCON,<SETPARMODE+ABASIC+AOUTPUT+CUPOUT+BBASIC+BINPUT+CDOWNOUT>

; INITIAL SETTINGS TO A/D
	MOV	AL,NORESET+NOSCLOCK+NOADSLEEP+NOHOLD+ENABLEMUX
	OUT	PARAA,AL

; FREEZE EDGE1 AND EDGE2 INTERRUPTS OFF
	OUTPT	PARC,00H

; HOLD VCO RESET
	RESETC0

; RESET SERIAL PORT
	CALL	RESSER

; ENABLE INTERRUPT DRIVE RS232 OUTPUT
	CALL	PUTCHBUFON

; RESET NMI INTERRUPT FLIPFLOP
IFNDEF	NONMI
	SETC7
ENDIF

; ENABLE INTERRUPTS
	INTON



; END 8088 INIT CODE
;

;**************************************************************
;
;	BACK TO MANX C STARTUP CODE
;
;**************************************************************



	mov	di,$MEMRY
	inc	di
	and	di,0fffeH	;adjust to word boundary
	mov	$MEMRY,di	;save memory allocation info for sbrk()
	mov	$MEMRY+2,ds
	mov	_mbot_,di
	mov	_mbot_,ds	; SHOULD THIS BE _mbot_+2?
	mov	sbot,0ffffH	;this is the heap limit for sbrk()
	mov	sbot+2,0fff0h
	mov	_dsval_,ds
	mov	_csval_,cs	;this is of dubious value in large code
	sti
	call	$fltinit	;setup floating point software/hardware
	jnc	flt_ok
	hlt			;program needs 8087 and one wasn't found
flt_ok:

	jmp	main_		;main shouldn't return in ROM based system
$begin	endp


	ASSUME CS:CODESEG,DS:DATASEG,ES:DATASEG,SS:DATASEG

procdef	SysInt	<<IntFlg,word>>
	pushf	;save flags on stack
	mov	ax,IntFlg
	or	ax,ax
	jne	si1
	INTOFF
	jmp	si2
si1:	INTON
si2:	pop	ax	;get flags
	and	ax,0200H ;remove all but interrupt bit
	pret
	pend	SysInt

procdef INTOFF
	INTOFF
	pret
	pend	INTOFF

;ENABLE INTERRUPTS
procdef INTON
	INTON
	pret
	pend	INTON

procdef GetAChar
	CALL	GETCH
	MOV	AH,0H
	pret
	pend	GetAChar


procdef LookAtChar
	MOV	AX,ISBFCNT	;SEE IF ANY CHARS THERE
	CMP	AX,0
	JE	M1X
	MOV	BX,ISBFOPT
	MOV	AL,[BX]			;GET CHAR
	MOV	AH,0
	pret

M1X:	MOV	AX,0FFFFH
	pret
	pend	LookAtChar


procdef	PutAChar	<<pchar,word>>
	mov	ax,pchar
	CALL	PUTCH
	pret
	pend	PutAChar

procdef	PutAWord	<<pword,word>>
	mov	ax,pword
	mov	al,ah
	CALL	PUTCH
	mov	ax,pword
	CALL	PUTCH
	pret
	pend	PutAWord

procdef	Pause	<<pcount,word>>
	mov	ax,pcount
	CALL	PAUSE
	pret
	pend	Pause

procdef	SetTick	<<stcountl,word>,<stcounth,word>>
	mov	NMIFRZ,0FFFFh
	mov	ax,stcounth
	mov	NMICNTH,ax
	mov	ax,stcountl
	mov	NMICNTL,ax
	mov	NMIFRZ,0h
	pret
	pend	SetTick

procdef	GetTick
	MOV	NMIFRZ,0FFFFH
	mov	ax,NMICNTL
	mov	dx,NMICNTH
	MOV	NMIFRZ,0H
	pret
	pend	GetTick

procdef	ResetVCO
	RESETC0		;hold line low for a while

; WAIT FOR A while
	MOV	AX,10
	CALL	PAUSE

	SETC0		;remove reset signal
	pret
	pend	ResetVCO

procdef	MEMPoke	<<Maddro,word>,<Mdata,word>>
	push	ax
	push	si
	mov	si,Maddro
	mov	ax,Mdata
	mov	[si],al
	pop	si
	pop	ax
	pret
	pend	MEMPoke

procdef	MEMPeek	<<Maddri,word>>
	push	si
	mov	si,Maddri
	mov	al,[si]
	mov	ah,00h
	pop	si
	pret
	pend	MEMPeek

procdef	IOPoke	<<addro,word>,<data,word>>
	push	ax
	push	dx
	mov	dx,addro
	mov	ax,data
	out	dx,al
	pop	dx
	pop	ax
	pret
	pend	IOPoke

procdef	IOPeek	<<addri,word>>
	push	dx
	mov	dx,addri
	in	al,dx
	mov	ah,00h
	pop	dx
	pret
	pend	IOPeek

procdef	Sleep
	CALL SLEEP
	pret
	pend	Sleep

procdef	GetAD	<<adport,word>>
	MOV	AX,adport
	CALL	GETAD
	pret
	pend	GetAD

procdef	ResetAD
	PUSH	AX
	PUSH	DX
	CALL	RESAD
	POP	DX
	POP	AX
	pret
	pend	ResetAD

;FORCE A HARD RESET
procdef	ColdReset

; MUST FIRST DISABLE NMI BY WAITING FOR IT, AND NOT
; RESETING FLIP FLOP
	JMP	$begin
	pret
	pend	ColdReset


GETAD:

;GET A/D VALUE FROM PREVIOUS CHANNEL, THEN SET UP NEW CHANNEL AS
; INDICATED BY ENTRY VALUE OF AX

;ASSUME WE START WITH NORESET,NOSCLOCK,NOADSLEEP,NOHOLD,
;   AND ENABLEMUX TO PROPER CHANNEL

;****SAVE REGS
	PUSH	CX
	PUSH	BX

;GALOOP:	MOV	NMIHAP,0H

;DISABLE INTERRUPTS
	INTOFF

;USING CHANNEL IN AX, MAKE NEXT MUX CONTROL WORD
	AND	AL,07H
	OR	AL,NORESET+NOSCLOCK+NOADSLEEP+NOHOLD+ENABLEMUX
	MOV	AH,AL

;	SETC1

;****ASSERT HOLD
	IN	AL,PARAA		;GET CURRENT MUX SETTING
	HOLDON
	OUT	PARAA,AL	; AND ASSERT HOLD

	MOV	AL,AH		;TURN OFF HOLD, AND ENABLE NEX MUX CHANNEL
	OUT	PARAA,AL

;****WAIT FOR TRACK1 RDY
TRKLP:	IN	AL,PARB		;GET BYTE
	AND	AL,02H		;STRIP OF OTHER BITS
	JNZ	TRKLP		;LOOP UNTIL BIT 1 IS A 0
TRKTHERE:
	
;	MOV	AL,AH		;TURN OFF HOLD, AND ENABLE NEX MUX CHANNEL
;	OUT	PARAA,AL

;****READ 16 BITS INTO BX
	MOV	CX,010H		;SET COUNT TO 16
ADLOOP:
	MOV	AL,AH
	SCLOCKON
	OUT	PARAA,AL	;TURN ON CLOCK
	MOV	AL,AH
	OUT	PARAA,AL	;TURN OFF CLOCK

	IN	AL,PARB
	ROR	AL,1		;GET BIT FROM PARC(0) INTO CF
	RCL	BX,1		;PUT IT IN BX
	LOOP	ADLOOP

;****XFER BX TO AX
;	RESETC0
;	RESETC1
	MOV	AX,BX

;ENABLE INTERRUPTS
	INTON

;CHECK NMIHAP
;	TEST	NMIHAP,0FFFFH
;	JZ	GAX
;;	JMP	GALOOP
;	MOV	AX,064H
;GAX:
;****RESTORE REG'S
	POP	BX
	POP	CX

	RET


; RESET A/D, MUX
RESAD:
; INVOKE THE RESET LINE
	MOV	AL,RESET + NOSCLOCK + NOADSLEEP + NOHOLD + ENABLEMUX + CHAN0
	OUTPT	PARAA,AL

; WAIT FOR AT LEAST ONE SECOND, THIS INSURES REFERENCE SETTLED
	MOV	AX,300
	CALL	PAUSE

; RESTORE RESET LINE
	MOV	AL,NORESET + NOSCLOCK + NOADSLEEP + NOHOLD + ENABLEMUX + CHAN0
	OUTPT	PARAA,AL

; WAIT FOR AT LEAST 2 SECONDS, THIS INSURES A/D CALIBRATED
	MOV	AX,600
	CALL	PAUSE
	RET


; RESSET SERIAL PORT
RESSER:	
	PUTSERCON 00H
	PUTSERCON 00H
	PUTSERCON 00H
	PUTSERCON 40H
	PUTSERCON 4EH
;	OUTPT	SERCON,0CEH	;1STOP,NOPARITY,8BIT,CLKX16
	PUTSERCON 37H
;	OUTPT	SERCON,15H	;CLEAR ERROR, ENABLE TRANSMITTER
	OUTPT	SERCON,37H	;CLEAR ERROR, ENABLE TRANSMITTER,RTS, DTR
;;	CALL	SERPAS
;;	CALL	SERPAS
	MOV	AX,OFFSET ISBUF
	MOV	ISBFIPT,AX
	MOV	ISBFOPT,AX
	MOV	AX,0H
	MOV	ISBFCNT,AX
	MOV	BYTE PTR PUTCHBUFFLAG,00H
SERPAS:	RET

DOSER:	PUSH	AX		;SAVE REGISTER
	GETSERCON
;	INPUT	SERCON		;GET STATUS OF UART
	AND     AL,02H	  ;SEE IF HOLDING A CHAR
	JE	SERINY		;EXIT IF NO CHAR THERE
	PUSH	BX		;SAVE ANOTHER REGISTER
	MOV	BX,ISBFIPT	;GET INPUT POINTER
	GETSERDAT
;	INPUT	SERDAT		;GET CHARACTER
	MOV	[BX],AL		;STORE CHARACTER THROUGH INPUT POINTER
	INC	BX		;INCREMENT POINTER
	CMP	BX,OFFSET ISBUF+ISBUFLEN
	JB	SERIN1		;JUMP IF BX IS BELOW THE END VALUE
	MOV	BX,OFFSET ISBUF
SERIN1:	MOV	ISBFIPT,BX	;RESTORE INPUT POINTER
	CMP	ISBFCNT,ISBUFLEN	; FULL BUFFER ALREADY?
	JE	SERIN2		; IF SO CONTINUE BELOW
	INC	ISBFCNT
	JMP	SERINX
SERIN2:	MOV	BX,ISBFOPT	;GET OUTPUT POINTER
	INC	BX		; INCREMENT IT
	CMP	BX,OFFSET ISBUF+ISBUFLEN	;CHECK FOR WRAP AROUND
	JB	SERIN3		;JUMP BELOW IF NONE
	MOV	BX,OFFSET ISBUF	;ELSE LOAD BASE VALUE
SERIN3:	MOV	ISBFOPT,BX	;RESTORE POINTER
SERINX:	POP	BX		;RESTORE REGISTER
SERINY:	POP	AX
	RET

DOPUTCH:
PCHECK:
	PUSH	AX
;CLEAR TRDY (EDGE1) FLIP FLOP
	RESETC6
	SETC6
;CHECK IF SERIAL OUTPUT PORT IS READY
	GETSERCON
	AND	AL,01H
	JE	DOPX		; IF NOT, THEN EXIT BELOW

;CHECK IF CHARS IN BUFFER
	MOV	AX,OSBFCNT
	CMP	AX,00H
	JE	DOPX		;IF NOT, THEN EXIT BELOW

; READY TO SEND ANOTHER CHARACTER!
; UPDATE COUNT
	DEC	AX
	MOV	OSBFCNT,AX

; GET NEXT CHARACTER FROM BUFFER
	PUSH	BX
	MOV	BX,OSBFOPT
	MOV	AL,[BX]
; SEND IT
	PUTSERDAT AL
;UPDATE POINTER INTO BUFFER
	INC	BX
	CMP	BX,OFFSET OSBUF+OSBUFLEN
	JB	DOP2
	MOV	BX,OFFSET OSBUF
DOP2:	MOV	OSBFOPT,BX
	POP	BX

; AND EXIT
DOPX:
	POP	AX
	RET

PUTCHBUFON:
; TURN ON PUTCHBUF FLAG
	MOV	BYTE PTR PUTCHBUFFLAG,0FFH

; RESET POINTERS AND COUNT
	PUSH	AX
	MOV	AX,OFFSET OSBUF
	MOV	OSBFIPT,AX
	MOV	OSBFOPT,AX
	MOV	AX,0
	MOV	OSBFCNT,AX

; RESET TRDY (EDGE1) FLIPFLOP
	RESETC6
	SETC6
	POP	AX
	RET

PUTCHBUFOFF:
	PUSH	AX
	PUSH	BX
	PUSH	CX

;CHECK IF IT IS ALREADY OFF
	MOV	AL,PUTCHBUFFLAG
	CMP	AL,00H
	JE	PBOFFX		;IF SO EXIT

; DISABLE TRDY (EDGE1) FLIPFLOP
	RESETC6

;TURN OF FLAG
	MOV	BYTE PTR PUTCHBUFFLAG,00H

;GET OUTPUT POINTER AND COUNT
	MOV	BX,OSBFOPT
	MOV	CX,OSBFCNT

;IF COUNT IS ZERO, THEN EXIT
	CMP	CX,00H
	JE	PBOFFX

;LOOP, USING OTHER PUTCH TO SEND REMAINING CHARS
PBOFF1:	MOV	AL,[BX]
	CALL	PUTCH
	INC	BX
	CMP	BX,OFFSET OSBUF+OSBUFLEN
	JB	PBOFF2
	MOV	BX,OFFSET OSBUF
PBOFF2:	LOOP	PBOFF1

PBOFFX:	POP	CX
	POP	BX
	POP	AX
	RET

PUTCHCHECK:
	PUSH	AX
	GETSERCON
;	INPUT	SERCON
	AND	AL,01H
	JE	PUTCHCHEKX
	MOV	AX,OSBFCNT
	CMP	AX,00H
	JE	PUTCHCHEKX
	DEC	AX
	MOV	OSBFCNT,AX
	PUSH	BX
	MOV	BX,OSBFOPT
PBCHK1:	MOV	AL,[BX]
	PUTSERDAT AL
;	OUTPT	SERDAT,AL
	INC	BX
	CMP	BX,OFFSET OSBUF+OSBUFLEN
	JB	PBCHK2
	MOV	BX,OFFSET OSBUF
PBCHK2:	MOV	OSBFOPT,BX
	POP	BX
PUTCHCHEKX:
	POP	AX
	RET
PUTCH:
	PUSH    AX
	MOV	AL,PUTCHBUFFLAG
	CMP	AL,00H
	JE	PUTCH1

	INTOFF
	MOV	AX,OSBFCNT
	CMP	AX,OSBUFLEN
	JE	PUTCHX1
	INC	AX
	MOV	OSBFCNT,AX
	POP	AX
	PUSH	AX
	PUSH	BX
	MOV	BX,OSBFIPT
	MOV	[BX],AL
	INC	BX
	CMP	BX,OFFSET OSBUF+OSBUFLEN
	JB	PUTCHX2
	MOV	BX,OFFSET OSBUF
PUTCHX2:
	MOV	OSBFIPT,BX
	POP	BX
PUTCHX1:
	INTON
	POP	AX
	INTOFF
	CALL	PCHECK
	INTON
	RET
;	JMP	PCHECK
;	RET
PUTCH1:
	GETSERCON
;	INPUT   SERCON
	AND     AL,01H	     ;SEE IF HOLDING
;	TEST	AL,01H
	JE      PUTCH1
	POP     AX
	PUTSERDAT AL
;	OUTPT  SERDAT,AL
	RET

GETNUM:	PUSH	DX
	PUSH	BX
	PUSH	CX
	MOV	CX,10
	MOV	BX,0
GTNMLP:	CALL	GETCH
	CALL	PUTCH
	AND	AX,07FH		;MASK OUT UNWANTED BITS
	CMP	AL,13		;IF RETURN, THEN EXIT
	JE	GETNUMX
	CMP	AL,'0'		;IF LESS THAN '0', TRY AGAIN
	JL	GTNMLP
	CMP	AL,'9'		;IF GT THAN '9', TRY AGAIN
	JG	GTNMLP
	SUB	AL,'0'		;TURN INTO NUMBER
	PUSH	AX		;SAVE DIGIT ON THE STACK
	MOV	AX,BX		;MULTIPLY CURRENT VALUE BY 10
	MUL	CX
	MOV	BX,AX
	POP	AX		;ADD DIGIT TO CURRENT VALUE
	ADD	BX,AX
	JMP	GTNMLP		;AND LOOP
	
GETNUMX:
	MOV	AX,BX		;RETURN VALUE IN AX
	POP	CX
	POP	BX
	POP	DX
	RET

GETCH:	PUSH	BX
GETCH1:
	MOV	AX,ISBFCNT
	CMP	AX,00H
	JE      GETCH2
	MOV	BX,ISBFOPT
	MOV	AL,[BX]			;GET CHAR
	PUSH	AX
;	DECREMENT COUNT
	DEC	ISBFCNT
;	UPDATE OUTPUT POINTER
	INTOFF
	INC	BX		; INCREMENT OUTPUT POINTER
	CMP	BX,OFFSET ISBUF+ISBUFLEN	;CHECK FOR WRAP AROUND
	JB	GETCH3		;JUMP BELOW IF NONE
	MOV	BX,OFFSET ISBUF	;ELSE LOAD BASE VALUE
GETCH3:	MOV	ISBFOPT,BX	;RESTORE POINTER
	INTON
	POP	AX
	POP	BX
	RET
GETCH2:
	CALL	SLEEP
	JMP	GETCH1
CR:
	MOV	AL,0DH
	CALL	PUTCH
	RET
CRLF:
	CALL	CR
	CALL	LF
	RET
LF:
	MOV     AL,0AH
	CALL    PUTCH
	RET
SPACE:
	MOV     AL,20H
	CALL    PUTCH
	RET
PRWORD:	PUSH	AX		;PRINTS A WORD IN HEX FORMAT
	PUSH	AX
	MOV	AL,AH
	CALL	PRBYTE
	POP	AX
	CALL	PRBYTE
	POP	AX
	RET
BACKWORD:	PUSH	AX		;PRINTS A WORD IN HEX FORMAT
	PUSH	AX
	CALL	PRBYTE
	POP	AX
	MOV	AL,AH
	CALL	PRBYTE
	POP	AX
	RET
TIMNIB:	PUSH	AX
	MOV	AL,AH
	CALL	PUTCHNIB
	POP	AX
	RET

PRBYTESP:
	CALL	PRBYTE
	CALL	SPACE
	RET
DISPDIG:
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	MOV	BX,0AH		;DIVISOR IS 10.
	MOV	CX,01H		;SET INITIAL COUNT TO 1
	CMP	AX,0H		;INITIAL ZERO?
	JE	DISPDIGLP3	; IF SO PRINT ONE ZERO AND EXIT
	MOV	CX,0H		;ELSE CLEAR COUNT AND ACCUM DIGITS
DISPDIGLP1:
	MOV	DX,0H		;CLEAR HIGH ORDER BYTE
	DIV	BX		;
	INC	CX		; UPDATE COUNT
	PUSH	DX		; SAVE DIGIT
	CMP	AX,0H		;DONE YET?
	JNE	DISPDIGLP1
DISPDIGLP2:
	POP	AX
DISPDIGLP3:
	CALL	PUTCHNIB	;SEND NIBBLE
	DEC	CX		;DECREASE CX
	JNE	DISPDIGLP2
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	RET
PRBYTE:
	PUSH    CX		;SAVE CX
	PUSH    AX		;SAVE AX
	SHR     AL,1
	SHR     AL,1
	SHR     AL,1
	SHR     AL,1
	CALL    PUTCHNIB
	POP     AX
	CALL    PUTCHNIB
	POP     CX
	RET
PRBYTEFILL:
	PUSH    CX		;SAVE CX
	PUSH    AX		;SAVE AX
	SHR     AL,1
	SHR     AL,1
	SHR     AL,1
	SHR     AL,1
	CALL    PUTCHNIB
	MOV	AL,AH
	CALL	PUTCH
	POP     AX
	CALL    PUTCHNIB
	POP     CX
	RET
PUTCHNIB:
	PUSH	AX
	AND     AL,0FH
	CMP     AL,0AH
	JL      PN1
	ADD     AL,07H
PN1:    ADD     AL,30H
	CALL    PUTCH
	POP	AX
	RET

SLEEP:	PUSH	AX
	OUTPT	SLEEPFLOP,0H
	POP	AX
	RET

PAUSE:	MOV	NMIFRZ,0FFFFH
	MOV	NMICNTH,0000H
	MOV	NMICNTL,AX
	MOV	NMIFRZ,0H
PAUSEL:
IFDEF	NONMI
	PUSH	CX
PAUSEL1:
	MOV	CX,2000
PAUSEL2:
	CMP	AX,CX
	LOOP	PAUSEL2
	DEC	AX
	JNZ	PAUSEL1
	POP	CX
ELSE
	TEST	NMICNTL,0FFFFH
	JZ	PAUSEX
	CALL	SLEEP
	JMP	PAUSEL
ENDIF
PAUSEX:	RET
   ;*************************************************************
   ;***              INTERRUPT CALLS                          ***
   ;*************************************************************

INT7:
	CALL	DOSER
	CALL	DOPUTCH
	CALL	DOCLOCK
	IRET
INT6:
	CALL	DOPUTCH
	CALL	DOCLOCK
	IRET
INT5:
	CALL	DOSER
	CALL	DOCLOCK
	IRET
INT4:
	CALL	DOCLOCK
	IRET
INT3:
	CALL	DOSER
	CALL	DOPUTCH
	IRET
INT2:
	CALL	DOPUTCH
	IRET
INT1:
	CALL	DOSER
	IRET

INTNMI:
IFDEF	NONMI
	IRET
ENDIF
	PUSH	AX

; RESET NMI INTERRUPT FLIPFLOP
	OUT	CLRNMI,AL
;	OUTPT	CLRNMI,00H	;RESET NMI FLIPFLOP

	POP	AX
	IRET




DOCLOCK:
	PUSH	AX
	RESETC7
	SETC7

	MOV	NMIHAP,0FFFFH
; CHECK COUNT DOWN TO ZERO COUNTER
	TEST	NMIFRZ,0FFFFH
	JNZ	INTNMIX

	TEST	NMICNTL,0FFFFH
	JNZ	INTDECIT

	TEST	NMICNTH,0FFFFH

; IF ZERO, THEN EXIT
	JZ	INTNMIX
	DEC	NMICNTH
	DEC	NMICNTL
	JMP	INTNMIX

INTDECIT:
; ELSE, DECREMENT BY 1
	DEC	NMICNTL

INTNMIX:
	INTON
	PUSH	BP
	PUSH	SI
	PUSH	DI
	PUSH	DX
	PUSH	CX
	PUSH	BX
	CALL	TickInt_
	POP	BX
	POP	CX
	POP	DX
	POP	DI
	POP	SI
	POP	BP

	INTOFF
	POP	AX
	RET

;SAMPLE INTERVAL INTERRUP ROUTINE
SAMPINT:
	PUSH	AX
	PUSH	DX
	PUSH	SI
	PUSH	DI

SMPIX:


	POP	DI
	POP	SI
	POP	DX
	POP	AX
	IRET

;____________________________________________________________________
;
;/////////////////////////   DATA SPACE   \\\\\\\\\\\\\\\\\\\\\\\\\\\
;____________________________________________________________________
;____________________________________________________________________

DATASEG	SEGMENT

ISBFIPT		DW	?
ISBFOPT		DW	?
ISBFCNT		DW	?
OSBFIPT		DW	?
OSBFOPT		DW	?
OSBFCNT		DW	?
PUTCHBUFFLAG	DB	?
LPOINT		DW	?
LLENGTH		DW	?

; REAL TIME CLOCK REGISTERS
MILLISECS	DW	?
SECOND		DW	?
NMICNTL		DW	?
NMICNTH		DW	?
NMIFRZ		DW	?
NMIHAP		DW	?

;	IF INTFLAG	= 0	THEN THE STATE OF THE INTERRUPT IS CHANGING
;			= 1	THEN SLOW INTERRUPTS ARE ON
;			=255	THEN FAST INTERRUPTS ARE ON

INTFLAG		DB	?

; A time sync VARIABLE USED TO remember when an edge has been received
EDGEFLAG	DW	?
; OUTPUT DATA REGISTERS
OUTBYTE		DB	?
BITCOUNT	DB	?
CTLFLAG		DB	?
OUTBUF		DB	?
BUFFUL		DB	?
NEWCTL		DB	?

ISBUFLEN EQU 100H
ISBUF		DB	ISBUFLEN DUP (?)

OSBUFLEN EQU 200H
OSBUF		DB	OSBUFLEN DUP (?)

DATASEG	ENDS
;****************************************************************
codeseg ends
	end	$begin

