/* FILE: mdemux.h                             (R. Cutler 04/30/91)
                                         (D. Tottingham  10/06/90)

This is an include file of defines, data structure definitions and
external declarations that are common in the mdemux module.

*/

#ifndef _MDEMUX_
#define _MDEMUX_

/************************************************************************
                               INCLUDES

************************************************************************/
#include "mconst.h"
#include "mqueue.h"


/************************************************************************
                                DEFINES

************************************************************************/
#define PRE_EVENT_TIME                  11      /* 11 seconds */

#define NEW_BUFFER                      3
#define AVAILABLE_BUFFER                2
#define ARCHIVED_BUFFER                 1

#define	DIGIREC_BOARD			1
#define	DT2821_BOARD			2

/************************************************************************
                        STRUCTURE DEFINITIONS


************************************************************************/
typedef struct {
        int far * channel_list;
        int far * gain_list;
        SUDS_STRUCTTAG structtag;
        SUDS_ATODINFO  info;
} DM_INFO;


/************************************************************************
                         EXTERNAL DECLARATIONS

These functions can be called from all modules that include this file.

************************************************************************/
PUBLIC FLAG		dm_buffer_full ();
PUBLIC int		dm_data_mid_point ();
PUBLIC float		dm_data_input_range();
PUBLIC float		dm_data_counts();
PUBLIC void		dm_dump_configuration (FILE *);
PUBLIC unsigned int	dm_get_channel_gain (unsigned int);
PUBLIC unsigned long	dm_get_channel_size ();
PUBLIC char		dm_get_clock_source ();
PUBLIC DM_INFO far *	dm_get_collect_info();
PUBLIC double		dm_get_current_time ();
PUBLIC double		dm_get_digitization_rate ();
PUBLIC Q_BUFFER far *	dm_get_first_buffer ();
PUBLIC Q_BUFFER far *	dm_get_head_buffer ();
PUBLIC void		dm_get_new_buffers ();
PUBLIC Q_BUFFER far *	dm_get_next_buffer ();
PUBLIC int		dm_get_number_of_ext_buffers ();
PUBLIC double		dm_get_pre_event_time ();
PUBLIC int		dm_get_scan_count ();
PUBLIC Q_BUFFER far *	dm_get_tail_buffer ();
PUBLIC void		dm_initialize ();
PUBLIC void		dm_initialize_params ();
PUBLIC void		dm_initialize_time ();
PUBLIC void		dm_reset ();
PUBLIC void 		dm_set_PreEventTime (double);

PUBLIC void		dm_initialize_buffers ();
PUBLIC void		dm_initialize_collection ();
PUBLIC void		dm_initialize_collect_params ();
PUBLIC void		dm_initialize_params ();
PUBLIC void		dm_initialize_time ();
PUBLIC void		dm_reset ();
PUBLIC void		dm_set_channel ();
PUBLIC void		dm_set_ChannelBlocksize ();
PUBLIC void		dm_set_ChannelGain ();
PUBLIC void		dm_set_ClockSource();
PUBLIC void		dm_set_DigitizationRate ();
PUBLIC void		dm_set_TriggerSource ();
PUBLIC void		dm_set_PreEventTime ();
PUBLIC void		dm_start_collection ();
PUBLIC void		dm_stop_collection ();

#endif
