/* FILE: mdigisup.h                             (R. Cutler 04/30/91)

This is an include file of the defines, data structure definitions and
external data declarations for using the digiserv module.

*/

#ifndef _MDIGISUP_
#define _MDIGISUP_

/************************************************************************
                               INCLUDES

************************************************************************/
#include "drcom.h"
#include "mconst.h"
#include "mqueue.h"
#include "mdemux.h"



/************************************************************************
                                DEFINES

************************************************************************/
/* Constants */

/*************************************************************************
 *			STRUCTURE DEFINITIONS
 ************************************************************************/

typedef struct xbuf {
		long length;
		long pointer;
		struct xbuf far * next;
		} X_BUF;

typedef struct drbuf {
		unsigned int type;
		unsigned int length;
		unsigned int status;
		struct drbuf * next;
		struct drbuf * last;
		long address;
		} DR_BUF;

typedef struct {
		int base_address;
		int device_id;
		int reserved_1;
		int scan_count;
		int channel_count;
		int dma_channel;
		int int_channel;
		int reserved[9];
		} DR_CONFIGURATION;


/************************************************************************
                         EXTERNAL DECLARATIONS

These functions can be called from all modules that include this file.

************************************************************************/

PUBLIC	unsigned int	dr_128K_blocks_used();
PUBLIC	int		dr_dma_status();
PUBLIC	int		dr_full_status();
PUBLIC	unsigned long	dr_get_dma_buffer();
PUBLIC	int		dr_init_xm(unsigned int blkcnt);
PUBLIC	unsigned int	dr_init_xm_buff(unsigned long buffersize);
PUBLIC	void		dr_irq_setup();
PUBLIC	void		dr_irq_restore();
PUBLIC	int		dr_isr();
PUBLIC	int		dr_issue_command (int comm, int parm);
PUBLIC	int		dr_nvread(int add, int *da);
PUBLIC	int		dr_nvwrite(int add, int da);
PUBLIC	int		dr_set_baud_rate(int comm, int parm);
PUBLIC	int		dr_set_dma_chan(int chan);
PUBLIC	int		dr_set_int_chan(int chan);
PUBLIC	int		dr_set_io_add(int add);
PUBLIC	int		dr_set_parity(int comm, int parm);
PUBLIC	void		dr_set_position(int chan, int wrd, int pos);
PUBLIC	int		dr_start_acq();
PUBLIC	int		dr_start_dma();
PUBLIC	int		dr_stop_acq();
PUBLIC	int		dr_stop_dma();
PUBLIC	int		dr_reset ();
PUBLIC	long		fpta(int far * point);
PUBLIC			printgrab(int far data[]);
PUBLIC			showhead();
#endif
